package com.yaohun.itemlibrary;

import cn.hamster3.cdapi.CDTimeAPI;
import com.yaohun.itemlibrary.data.SortData;
import com.yaohun.itemlibrary.gui.SortGui;
import com.yaohun.itemlibrary.manage.SortManager;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

public class main extends JavaPlugin {

    public static SortManager sortManager;
    public static main plugin;
    @Override
    public void onEnable() {
        plugin = this;
        sortManager = new SortManager();
        getServer().getPluginManager().registerEvents(new SortGui(),this);
    }

    @Override
    public void onDisable() {
        sortManager.SaveSortData();
    }


    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
        if(!sender.isOp()){return true;}
        if (args.length == 0) {
            sender.sendMessage("/ditem sort [分类名] --- 打开分类/创建分类");
            sender.sendMessage("/ditem [分类名] [物品名] --- 保存物品");
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("reload")){
            sortManager = new SortManager();
            SortGui.playerListHashMap.clear();
            DemonAPI.sendMessage(sender,"缓存数据和配置文件已重载.");
        }
        if(args.length == 2){
            if(args[0].equalsIgnoreCase("sort")) {
                Player player = (Player) sender;
                String sortName = args[1];
                if (sortManager.isSortFileExit(sortName)) {
                    SortGui.OpenGui(player, sortName, 1);
                } else {
                    long createRequest = CDTimeAPI.getCD(player.getUniqueId(), "create_request");
                    if (createRequest < 0) {
                        DemonAPI.sendMessage(sender, "分类不存在§e创建文件§a请再次输入此命令.", Sound.ENTITY_VILLAGER_NO);
                        CDTimeAPI.setPlayerCD(player.getUniqueId(), "create_request", 1000 * 5);
                        return true;
                    }
                    sortManager.createSortFile(sortName);
                    DemonAPI.sendMessage(sender, "分类文件§e" + sortName + "§a创建成功.", Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }
            } else {
                String sortName = args[0];
                Player player = (Player) sender;
                ItemStack item = player.getInventory().getItemInMainHand();
                if (DemonAPI.itemIsNull(item) || DemonAPI.itemIsLore(item) || DemonAPI.itemIsName(item)) {
                    DemonAPI.sendMessage(player, "当前手持物品无法保存至物品库.",Sound.ENTITY_VILLAGER_NO);
                    return true;
                }
                if (!sortManager.isSortFileExit(sortName)) {
                    DemonAPI.sendMessage(player, "分类§e"+sortName+"§a并不存在.",Sound.ENTITY_VILLAGER_NO);
                    return true;
                }
                SortData sortData = sortManager.getSortData(sortName);
                String itemKey = args[1];
                if(sortData.isStackExit(itemKey)){
                    sortData.deleteStackMap(itemKey);
                    DemonAPI.sendMessage(player, "删除物品: §c" + itemKey + " §a分类: §6"+sortName, Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }else {
                    sortData.setStackMap(itemKey, item);
                    DemonAPI.sendMessage(player, "创建物品: §e" + itemKey + " §a分类: §6"+sortName, Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }
            }
        }
        return false;
    }
}
